/*

Copyright (c) 2006. All Rights reserved.

If you use this script, please email me and let me know, thanks!

Andrew Hedges
andrew (at) hedges (dot) name

If you want to hire me to write JavaScript for you, see my resume.

http://andrew.hedges.name/resume/

*/

////////////////////////////////////////////////////////////////////////////
// DEBUG

// var debug = true;
var debug = false;
var debugObj;

function writeDebug(s) {
	if (window.widget) {
		alert(s);
	} else {
		debugObj.innerHTML += s + "<br>";
	}
}

function revealObject(o) {
	for (p in o) {
		writeDebug(p);
	}
}

// DEBUG
////////////////////////////////////////////////////////////////////////////

var wdw = window;
var doc = document;

var currentFunctionsArray, historyArray;
var timer, opacityTimer;
var lang, installedLangs;
var favoriteLink, arrowsHTML;

var delay = 200;
var lastHilite = "";
var favsShowing = false;
var basePath = document.location.href.substring(5,document.location.href.length-12);

var funcRegexp		= /_/g; // we use this to replace the underscores in the function names with dashes to match the file names
var selectedRegexp	= /selected/; // we use this to remove the hilites from the function list

var linkRegexp	= /<a/ig;
var linkReplace	= '<a onclick="followLink(this.href);return false;"';

/*
// this is the object that will store values for vertical window resizing
var resizer = {
	minwheight:210,
	maxheight:610,
	curheight:410,
	start:null
};
*/

var defaultList = '';
defaultList += '<div onclick="doShowBack();" class="odd">';
defaultList += '	<!-- en -->';
defaultList += '	No languages are currently installed. Please flip the widget over and click on the language of your choice.';
defaultList += '</div>';
defaultList += '<div onclick="doShowBack();" class="even">';
defaultList += '	<!-- es -->';
defaultList += '	No est&#225; instalado ning&#250;n idiomas actualmente. Por favor mueva de un tir&#243;n el widget y selecione el idioma de su opci&#243;n.';
defaultList += '</div>';
defaultList += '<div onclick="doShowBack();" class="odd">';
defaultList += '	<!-- fr -->';
defaultList += '	Aucune langue n&#8217;est actuellement install&#233;e. Veuillez renverser le widget et cliquer sur la langue de votre choix.';
defaultList += '</div>';
defaultList += '<div onclick="doShowBack();" class="even">';
defaultList += '	<!-- de -->';
defaultList += '	Keine Sprachen werden z.Z. angebracht. Schlagen Sie bitte das widget r&#252;ber leicht und klicken Sie an die Sprache Ihrer Wahl.';
defaultList += '</div>';
defaultList += '<div onclick="doShowBack();" class="odd">';
defaultList += '	<!-- ja -->';
defaultList += '	言語は現在インストールされていない。仕掛を弾き、選択の言語をつけなさい。';
defaultList += '</div>';
defaultList += '<div onclick="doShowBack();" class="even">';
defaultList += '	<!-- ru -->';
defaultList += '	Никакие языки в настоящее время не установлены. Пожалуйста flip widget сверх и 5elknite дальше языком вашего выбора.';
defaultList += '</div>';
defaultList += '<div onclick="doShowBack();" class="odd">';
defaultList += '	<!-- nl -->';
defaultList += '	Geen talen zijn momenteel geïnstalleerd. Gelieve te knippen over widget weg en te klik op de taal van uw keus.';
defaultList += '</div>';
defaultList += '<div onclick="doShowBack();" class="even">';
defaultList += '	<!-- cn (simplified) -->';
defaultList += '	语言当前不被安装。请翻转小部件和点击您的选择语言。';
defaultList += '</div>';
defaultList += '<div onclick="doShowBack();" class="odd">';
defaultList += '	<!-- pt_BR -->';
defaultList += '	Nenhuma l&#237;ngua &#233; instalada atualmente. Lance por favor o widget sobre e estale sobre a l&#237;ngua de sua escolha.';
defaultList += '</div>';
defaultList += '<div onclick="doShowBack();" class="even">';
defaultList += '	<!-- it -->';
defaultList += '	Nessun linguaggio attualmente &#232; installato. Lanci prego il widget sopra e scatti sopra il linguaggio della vostra scelta.';
defaultList += '</div>';
defaultList += '<div onclick="doShowBack();" class="odd">';
defaultList += '	<!-- el -->';
defaultList += '	Καμία γλώσσα δεν εγκαθίσταται αυτήν την περίοδο. Παρακαλώ κτυπήστε το widget και χτυπήστε στη γλώσσα της επιλογής σας.';
defaultList += '</div>';

var statusMessages	= new Array();
statusMessages["ready"]			= "Ready";
statusMessages["downloading"]	= "Downloading&#8230;Please wait.";
statusMessages["complete"]		= "Installation complete.";
statusMessages["nolangs"]		= "No languages installed";
//	statusMessages[""]	= "";

var tips = new Array(
	"Use regular expressions to search (e.g., ^.*[0-9]$).",
	"Copy selected text in the function frame using cmd-c",
	"Scroll the function list using up- and down-arrows",
	"Add functions to your favorites using the plus image"
);
//	"This is a tip that pushes the max line length. Capiche?" // maximum line length for tips

// pieces needed to link into the online documentation for the selected language
var onlineDocsLinks = new Array(
	"http://www.php.net/manual/",
	"/function.",
	".php"
);

var favoritesHTML = new Array();
favoritesHTML["add"]	= new Array(
	'<img onclick="toggleFavorite(\'',
	'\');" id="favorites_control" src="images/favorites_add.png" title="Add this page to your favorites" alt=""/>'
);
favoritesHTML["remove"]	= new Array(
	'<img onclick="toggleFavorite(\'',
	'\');" id="favorites_control" src="images/favorites_remove.png" title="Remove this page from your favorites" alt=""/>'
);

var backHTML = new Array();
backHTML["loaded"]		= new Array('<img onclick="goBack();" id="back_control" src="images/back_loaded.png" title="Show the previous page" alt=""/>');
backHTML["not_loaded"]	= new Array('<img id="back_control" src="images/back_not_loaded.png" title="Show the previous page" alt=""/>');

var forwardHTML = new Array();
forwardHTML["loaded"]		= new Array('<img onclick="goForward();" id="forward_control" src="images/forward_loaded.png" title="Show the next page" alt=""/>');
forwardHTML["not_loaded"]	= new Array('<img id="forward_control" src="images/forward_not_loaded.png" alt=""/>');

var objIds = new Array("filterField","functionList","functionFrameParent","functionFrame","status","status_text","tip_text");
var objs = new Array();

var listScrollBar, listScrollArea, viewerScrollBar, viewerScrollArea;

var favorites;

function init() {
	if (debug) {
		debugObj = getObj("debug");
		debugObj.style.display = "block";
	}
	
//	setPref('false','lang');
	
	// get object references
	for (o = objIds.length-1; o > -1; o--) {
		objs[objIds[o]] = getObj(objIds[o]);
	}
	
	// initialize scrollbars
	listScrollBar  = new AppleVerticalScrollbar(doc.getElementById("listScrollBar"));
	listScrollArea = new AppleScrollArea(doc.getElementById("functionListParent"), listScrollBar);
	listScrollArea.scrollsHorizontally = false;
	listScrollArea.singlepressScrollPixels = 25;
	listScrollArea.focus(); 
	
	viewerScrollBar  = new AppleVerticalScrollbar(doc.getElementById("viewerScrollBar"));
	viewerScrollArea = new AppleScrollArea(doc.getElementById("functionFrameParent"), viewerScrollBar);
	viewerScrollArea.scrollsHorizontally = false;
	viewerScrollArea.singlepressScrollPixels = 25;
	
	window.onfocus = function () { listScrollArea.focus(); }
	window.onblur = function () { listScrollArea.blur(); }
	wdw.widget.onshow = onShow;
	
	// enable vertical resizing of window
//	objs["resizer"].addEventListener("mousedown",mouseDownResizer,true);
	
	// enable horizontal resizing of window
	stretcher = new Stretcher(doc.getElementById("front"), 600, 600, toggleFunctionFrame);
	
	// figure out which langauges are installed
	installedLangs = getInstalledLangs();
	
	// set up full list
	if (installedLangs == " ") {
		setStatus("nolangs");
		showDefaultList();
		listScrollArea.refresh();
	} else {
		lang = getPref("lang");
		if (!lang || lang == "false") getLang();
		if (!lang || lang == "false") lang = setDefaultLang(installedLangs);
		setLangRadio(lang);
		doFilter("");
	}
	
	// set help page as the default
	wdw.widget.system("/usr/bin/php scripts/return_html.php '"+basePath+"html/help.html'",writeFunctionFrame);
	
	// clear history
	clearHistory();
	
	// build buttons for the backside
	createGenericButton(doc.getElementById("donateButton"), "Donate", null);
	createGenericButton(doc.getElementById("doneButton"), "Done", null);
}

writeFunctionFrame = function (obj) {
	objs["functionFrame"].innerHTML = obj.outputString.replace(linkRegexp,linkReplace);
}

function toggleFunctionFrame() {
	if (stretcher.isStretched()) {
		doc.getElementById("viewerScrollBar").style.display = "block";
		opacityTimer = setInterval("increaseOpacity()",10);
	} else {
		doc.getElementById("viewerScrollBar").style.display = "none";
		objs["functionFrameParent"].style.opacity = 0;
	}
}

function increaseOpacity() {
	if (objs["functionFrameParent"].style.opacity > 0.9) {
		clearInterval(opacityTimer);
		viewerScrollArea.refresh();
	} else {
		var newOpacity = 1 * objs["functionFrameParent"].style.opacity + 0.1;
		objs["functionFrameParent"].style.opacity = newOpacity;
	}
}

function takeInput(pattern) {
	clearTimeout(timer);
	timer = setTimeout("doFilter('"+pattern+"')",delay);
}

function doFilter(pattern) {
	if (lang.length > 1) {
		lastHilite = "";
		objs["filterField"].value = pattern;
		// if we're resetting the list, take a short-cut
		if (pattern == "") {
			// copy the full function list into the current function list
			currentFunctionsArray = functionsArray;
		} else {
			regexp = new RegExp(pattern,'i');
			currentFunctionsArray = new Array();
			for (var f = functionsArray.length-1; f > -1; f--) {
				if (regexp.test(functionsArray[f])) currentFunctionsArray[currentFunctionsArray.length] = functionsArray[f];
			}
		}
		favsShowing = false;
		// rebuild the list
		buildOptions(currentFunctionsArray);
	}
}

function buildOptions(arrayName) {
	newHTML = "";
	arrayName.sort();
	// build the select list
	for (var f = 0; f < arrayName.length; f++) {
		evenOdd = (f % 2)? "even": "odd";
		newHTML += '<div id="'+arrayName[f]+'" class="'+evenOdd+'" onclick="showFunction('+"'"+arrayName[f]+"'"+');" ondblclick="gotoOnlineDoc('+"'"+arrayName[f]+"'"+');">'+arrayName[f]+'<\/div>';
	}
	objs["functionList"].innerHTML = newHTML;
	listScrollArea.verticalScrollTo(0);
	listScrollArea.refresh();
}

function hiliteFunction(func) {
	// unhilite last hilited func
	if (lastHilite !== "") {
		if (doc.getElementById(lastHilite)) {
			doc.getElementById(lastHilite).className = doc.getElementById(lastHilite).className.replace("selected","");
		}
	}
	
	// hilite current function
	if (func !== "" && doc.getElementById(func)) {
		doc.getElementById(func).className += " selected";
		lastHilite = func; // store last hilited func
	}
}

function downloadManual(lang) {
	gotoURL("http://www.php.net/get/php_manual_"+lang+".tar.gz/from/a/mirror");
}

function setStatus(idx) {
	objs["status_text"].innerHTML = statusMessages[idx];
}

function changeTip() {
	objs["tip_text"].innerHTML = tips[rand(tips.length)];
}

// decide whether to add or remove the favorite
function toggleFavorite(func) {
	if (in_array(favorites,func)) {
		removeFavorite(func);
	} else {
		addFavorite(func);
	}
}

// add a favorite to the saved list
function addFavorite(func) {
	var idx = favorites.length;
	favorites[idx] = func;
	doc.getElementById("favorites_control").src	= "images/favorites_remove.png";
	doc.getElementById("favorites_control").title	= "Click to remove this page from your favorites";
	if (favsShowing) buildOptions(favorites);
	setFavorites();
}

// remove a favorite from the saved list
function removeFavorite(func) {
	var idx = array_pos(favorites,func);
	if (idx !== false) favorites.splice(idx,1);
	doc.getElementById("favorites_control").src	= "images/favorites_add.png";
	doc.getElementById("favorites_control").title	= "Click to add this page to your favorites";
	if (favsShowing) buildOptions(favorites);
	setFavorites();
}

// get list of favorites from user's preferences
function getFavorites() {
	favPrefs = getPref("favorites");
	favorites = (favPrefs !== false)? favPrefs.split(","): favorites = new Array();
}

// set list of favorites to user's preferences
function setFavorites() {
	setPref(favorites.toString(),"favorites");
}

function getPref(key) {
	return (wdw.widget.preferenceForKey(key) === undefined)? false: wdw.widget.preferenceForKey(key);
}

function setPref(val,key) {
	wdw.widget.setPreferenceForKey(val,key);
}

function getLang() {
	radios = document.installForm.lang;
	var lang = false;
	for (var l = 0; l < radios.length; l++) {
		if (radios[l].checked) {
			var lang = radios[l].value;
			break;
		}
	}
	return lang;
}

function onShow() {
	getInstalledLangs();
}

function getInstalledLangs() {
	wdw.widget.system("/usr/bin/php scripts/installed.php",setInstalledLangs);
}

setInstalledLangs = function (obj) {
	installed_langs = obj.outputString;
	var langs = document.installForm.lang;
	for (var l = langs.length-1; l > -1; l--) {
		langs[l].disabled = (installed_langs.indexOf(langs[l].value) < 0);
	}
}

function setDefaultLang(installedLangs) {
	if (installedLangs === undefined) {
		var lang = "en";
	} else {
		var langs = installedLangs.split(" ");
		if (langs.length > 0) {
			var lang = langs[0];
		} else {
			var lang = "en";
		}
	}
	setPref(lang,'lang');
	return lang;
}

function setLangRadio(lang) {
	var langs = document.installForm.lang;
	for (var l = langs.length-1; l > -1; l--) {
		if (lang == langs[l].value) {
			langs[l].checked = true;
			break;
		}
	}
}

function gotoOnlineDoc(func) {
	url = onlineDocsLinks[0] + lang + onlineDocsLinks[1] + func.replace(funcRegexp,"-") + onlineDocsLinks[2];
	gotoURL(url);
}

function gotoURL(url) {
	if (window.widget) {
		wdw.widget.openURL(url);
	} else {
		location.href = url;
	}
}

function getObj(id) {
	return doc.getElementById(id);
}

/***************************/
/* BEGIN: RESIZE FUNCTIONS */

/*
// user clicked down on the resizer handle
function mouseDownResizer(event) {
	resizer.start = event.y;
	
	// add resizer handle listeners
	document.addEventListener("mousemove",mouseMoveResizer,true);
	document.addEventListener("mouseup",mouseUpResizer,true);
}

// user let go of click on the resizer handle
function mouseUpResizer(event) {
	resizer.start	= null;
	
	// remove resizer handle listeners
	document.removeEventListener("mousemove",mouseMoveResizer,true);
	document.removeEventListener("mouseup",mouseUpResizer,true);
}

// user moved mouse while clicking on the resizer handle
function mouseMoveResizer(event) {
	// change height to reflect move
	if (resizer.start) {
		// figure out how far we need to move the objects (always 1 or -1?)
		diff = resizer.start - event.y;

		// set current y to be the new start y
		resizer.start = event.y;

		if ((parseInt(objs["front"].style.height) - diff) < resizer.minheight) {
			resizer.start += resizer.minheight - (parseInt(objs["front"].style.height) - diff);
			diff = parseInt(objs["front"].style.height) - resizer.minheight;
		}
		
		if ((parseInt(objs["front"].style.height) - diff) > resizer.maxheight) {
			resizer.start += resizer.maxheight - (parseInt(objs["front"].style.height) - diff);
			diff = parseInt(objs["front"].style.height) - resizer.maxheight;
		}

		// resize objects
		objs["front"].style.height 			= (parseInt(objs["front"].style.height) - diff) + "px";
		objs["functionFrame"].style.height	= (parseInt(objs["functionFrame"].style.height) - diff) + "px";
			
	}
}
*/

/* END: RESIZE FUNCTIONS */
/*************************/
// Feb 1, 2006 Wednesday 9:05:30 pm

formatChars = "dDjlNSwzWFmMntLoYyaABgGhHiseIOTZcrU";

var formats = new Array();
formats["d"] = "01";
formats["D"] = "Wed";
formats["j"] = "1";
formats["l"] = "Wednesday";
formats["N"] = "3";
formats["S"] = "st";
formats["w"] = "4";
formats["z"] = "32";
formats["W"] = "5";
formats["F"] = "February";
formats["m"] = "02";
formats["M"] = "Feb";
formats["n"] = "2";
formats["t"] = "28";
formats["L"] = "0";
formats["o"] = "2006";
formats["Y"] = "2006";
formats["y"] = "06";
formats["a"] = "pm";
formats["A"] = "PM";
formats["B"] = "212";
formats["g"] = "9";
formats["G"] = "21";
formats["h"] = "09";
formats["H"] = "21";
formats["i"] = "05";
formats["s"] = "30";
formats["e"] = "MST";
formats["I"] = "0";
formats["O"] = "-0700";
formats["T"] = "MST";
formats["Z"] = "-25200";
formats["c"] = "2006-02-01T21:05:30+00:00";
formats["r"] = "Wed; 01 Feb 2006 21:05:30 -0700";
formats["U"] = "1138853130";

var constants = new Array();
constants["DATE_ATOM"]		= "2005-08-15T15:52:01+0000";
constants["DATE_COOKIE"]	= "Mon; 15 Aug 2005 15:52:01 UTC";
constants["DATE_ISO8601"]	= "2005-08-15T15:52:01+0000";
constants["DATE_RFC822"]	= "Mon; 15 Aug 2005 15:52:01 UTC";
constants["DATE_RFC850"]	= "Monday; 15-Aug-05 15:52:01 UTC";
constants["DATE_RFC1036"]	= "Monday; 15-Aug-05 15:52:01 UTC";
constants["DATE_RFC1123"]	= "Mon; 15 Aug 2005 15:52:01 UTC";
constants["DATE_RFC2822"]	= "Mon; 15 Aug 2005 15:52:01 +0000";
constants["DATE_RSS"]		= "Mon; 15 Aug 2005 15:52:01 UTC";
constants["DATE_W3C"]		= "2005-08-15T15:52:01+0000";

function showFormat(idx) {
	if (idx.length > 0) {
		doc.getElementById("date_display").innerHTML = "";
		str = doc.getElementById("date_string").value;
		for (var c = 0; c < str.length; c++) {
			if (str.charAt(c-1) == "\\") {
				doc.getElementById("date_display").innerHTML += str.charAt(c);
			} else {
				doc.getElementById("date_display").innerHTML += (formatChars.indexOf(str.charAt(c)) < 0)? (str.charAt(c) == " ")? "&nbsp;": str.charAt(c): formats[str.charAt(c)];
			}
		}
	} else {
		showDefault();
	}
}

function showLinkedDate(str) {
	doc.getElementById("date_string").value = str;
	showFormat(str);
}

function showConstant(sel) {
	var idx = sel.options[sel.selectedIndex].value;
	if (idx !== "false") {
		doc.getElementById("date_string").value = idx;
		doc.getElementById("date_display").innerHTML = constants[idx];
	} else {
		showDefault();
	}
}

function showDefault() {
	doc.getElementById("date_display").innerHTML = "Enter a format below or choose a date constant (PHP 5.1 only)";
}

function fetchHTML(fullPath) {
	if (lang == 'tw' || lang == 'hk') {
		wdw.widget.system("/usr/bin/php scripts/return_html.php '"+fullPath+"' | iconv -f BIG5 -t UTF-8",showHTML);
	} else if (lang == 'ro') {
		wdw.widget.system("/usr/bin/php scripts/return_html.php '"+fullPath+"' | iconv -f ISO-8859-2 -t UTF-8",showHTML);
	} else {
		wdw.widget.system("/usr/bin/php scripts/return_html.php '"+fullPath+"'",showHTML);
	}
}

showHTML = function (obj) {
	var html = '<div id="controls_space"><\/div>'+favoriteLink+arrowsHTML+obj.outputString.replace(linkRegexp,linkReplace);
	objs["functionFrame"].innerHTML = html;
	viewerScrollArea.verticalScrollTo(0);
	viewerScrollArea.refresh();
}

function showFunction(func) {
	if (lang.length > 1) {
		if (!stretcher.isStretched()) stretcher.stretch();
		hiliteFunction(func);
		getFavorites();
		var inFavs = (in_array(favorites,func))? "remove": "add";
		favoriteLink = favoritesHTML[inFavs][0]+func+favoritesHTML[inFavs][1];
		var backLoaded = (historyIndex > 0)? "loaded": "not_loaded";
		var forwardLoaded = (historyIndex < historyArray.length-1)? "loaded": "not_loaded";
		arrowsHTML = backHTML[backLoaded] + forwardHTML[forwardLoaded];
		var fullPath = basePath+"php_manual/"+getPref("lang")+"/function."+func.replace(funcRegexp,"-")+".html";
		fetchHTML(fullPath);
		addHistoryItem(func);
	}
}

function followLink(href) {
	// if this is a function page, convert the href to a func and go there
	if (href.indexOf("function.") > 0) {
		var func = href.substring(href.indexOf("function.")+9,href.length-5);
		func = func.replace(/-/g,"_");
		showFunction(func);
	} else { // go straight to the page
		var hrefPieces = href.split("/");
		href = hrefPieces[hrefPieces.length-1];
		if (href.indexOf("#") > 0) href = href.substring(0,href.indexOf("#"));
		getFavorites();
		var inFavs = (in_array(favorites,func))? "remove": "add";
		favoriteLink = favoritesHTML[inFavs][0]+func+favoritesHTML[inFavs][1];
		var backLoaded = (historyIndex > 0)? "loaded": "not_loaded";
		var forwardLoaded = (historyIndex < historyArray.length-1)? "loaded": "not_loaded";
		arrowsHTML = backHTML[backLoaded] + forwardHTML[forwardLoaded];
		var fullPath = basePath+"php_manual/"+getPref("lang")+"/"+href.replace(funcRegexp,"-");
		fetchHTML(fullPath);
		addHistoryItem(href);
	}
}

function showPage(page) {
	if (!stretcher.isStretched()) stretcher.stretch();
	hiliteFunction("");
	wdw.widget.system("/usr/bin/php scripts/return_html.php '"+basePath+page+".html'",displayPage);
}

displayPage = function (obj) {
	writeFunctionFrame(obj);
	viewerScrollArea.verticalScrollTo(0);
	viewerScrollArea.refresh();
}

function clearHistory() {
	historyArray = new Array();
	historyIndex = 0;
	updateHistoryArrows();
}

function addHistoryItem(item) {
	if ((historyArray.length == 0 || historyIndex == historyArray.length-1) && item !== historyArray[historyIndex]) {
		if (item.indexOf(".") < 0) item = "function." + item + ".html";
		historyArray.splice(historyIndex,historyArray.length-historyIndex-1); // remove everything from the current spot forward
		historyArray[historyArray.length] = item; // add the current item
		// allow a maximum of 64 history items (for performance reasons)
		while (historyArray.length > 64) {
			historyArray.splice(0,1); // remove the first item from the array
		}
		historyIndex = historyArray.length-1;
	}
	updateHistoryArrows();
}

function updateHistoryArrows() {
	if (historyArray.length == 0) {
		updateBackLoaded("not_loaded");
		updateForwardLoaded("not_loaded");
	} else {
		// back arrow
		var status = (historyIndex > 0)? "loaded": "not_loaded";
		updateBackLoaded(status);
		
		// forward arrow
		var status = (historyIndex < historyArray.length-1)? "loaded": "not_loaded";
		updateForwardLoaded(status);
	}
}

function goBack() {
	historyIndex--;
	if (historyIndex < 0) historyIndex = 0;
	followLink(historyArray[historyIndex]);
	updateHistoryArrows();
}

function goForward() {
	historyIndex++;
	if (historyIndex > historyArray.length-1) historyIndex = historyArray.length-1;
	followLink(historyArray[historyIndex]);
	updateHistoryArrows();
}

function updateBackLoaded(status) {
	if (doc.getElementById("back_control")) doc.getElementById("back_control").src = "images/back_"+status+".png";
}

function updateForwardLoaded(status) {
	if (doc.getElementById("forward_control")) doc.getElementById("forward_control").src = "images/forward_"+status+".png";
}

function showFavorites() {
	objs["filterField"].value = "";
	favsShowing = true;
	getFavorites();
	buildOptions(favorites);
	listScrollArea.verticalScrollTo(0);
	listScrollArea.refresh();
}

function showDefaultList() {
	objs["functionList"].innerHTML = defaultList;
}

function showSection(sect) {
	// show the proper tab
	var tabs_container = doc.getElementById("tabs_nav");
	var tabs = tabs_container.getElementsByTagName("div");
	for (var t = tabs.length-1; t > -1; t--) {
		tabs[t].className = "";
	}
	var tab = doc.getElementById(sect+"_tab");
	tab.className = "selected";
	
	// show the proper section
	var codes_container = doc.getElementById("codes_container");
	var codes = codes_container.getElementsByTagName("div");
	for (var c = codes.length-1; c > -1; c--) {
		codes[c].style.display = "none";
	}
	var code = doc.getElementById(sect+"_codes");
	code.style.display = "block";
	
	// adjust the scrollbar
	viewerScrollArea.refresh();
}

function showFAQ(item) {
	hideBack();
	showPage("html/help");
	showSection("faq");
	viewerScrollArea.reveal(doc.getElementById("how_do_i_install"));
}

function copy2pasteboard(s) {
	if (window.widget) wdw.widget.system("/bin/echo -n '"+s.toString()+"' | /usr/bin/pbcopy", null);
}

function in_array(array_name, search_term) {
	for (var i = array_name.length-1; i > -1; i--) {
		if (array_name[i] === search_term) {
			return true;
		}
	}
	return false;
}

function array_pos(array_name, search_term) {
	for (var i = array_name.length-1; i > -1; i--) {
		if (array_name[i] === search_term) {
			return i;
		}
	}
	return false;
}

/* begin: version checking functions */
function doCheckVersion() {
	// figure out whether we have a 'net connection
	var ip = window.widget.system('ifconfig | grep "inet " | grep -v 127.0.0.1 | cut -d\\  -f2',null).outputString;
	
	if (!!ip) {
		checkVersion('phpfr');
		document.getElementById('vrsn_link').innerHTML = 'Checking for Updates&#8230;';
	} else {
		document.getElementById('vrsn_result').innerHTML = 'Error: '+version_errors['-2'];
	}
}

function returnVersion(vrsn) {
	var vrsnObj = getObj('vrsn_result');
	
	///////////////////////////////////////
	// WIDGET VERSION: UPDATE EACH VERSION!
	
	var thisvrsn = '0.9.6.2b';
	
	if (thisvrsn == vrsn) { // up-to-date
		vrsnObj.innerHTML = 'This widget is up-to-date.';
	} else {
		if (vrsn.indexOf('-') > -1) { // error
			vrsnObj.innerHTML = 'Error: '+version_errors[vrsn];
		} else { // new version available
			vrsnObj.innerHTML = 'New version available. <span class="link" onclick="gotoURL(\'http://andrew.hedges.name/widgets/#phpfr\');vrsnMsgBlank();">Go to download page.<\/span>';
		}
	}
	document.getElementById('vrsn_link').innerHTML = 'Check for Updates';
}

function vrsnMsgBlank() {
	var vrsnObj = getObj('vrsn_result');
	vrsnObj.innerHTML = '';
}
/* end: version checking functions */

// The Central Randomizer 1.3 (C) 1997 by Paul Houle (houle@msc.cornell.edu)
// See:  http://www.msc.cornell.edu/~houle/JavaScript/randomizer.html
// Usage: rand(n) returns random integer between 0 and n-1

rnd.today = new Date();
rnd.seed  = rnd.today.getTime();

function rnd() {
	rnd.seed = (rnd.seed*9301+49297) % 233280;
	return rnd.seed/(233280.0);
}

function rand(number) {
	return Math.ceil(rnd()*number)-1;
}

window.onload = init;
